import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCardUserLog, ThinkCardUserLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkCardUserLog(params: ThinkCardUserLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCardUserLog>>>(
    THINK_API_URL + '/think/think-card-user-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkCardUserLog(params?: ThinkCardUserLogParam) {
  const res = await request.get<ApiResult<ThinkCardUserLog[]>>(
    THINK_API_URL + '/think/think-card-user-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkCardUserLog(data: ThinkCardUserLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-user-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkCardUserLog(data: ThinkCardUserLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-user-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkCardUserLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-user-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkCardUserLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-user-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkCardUserLog(id: number) {
  const res = await request.get<ApiResult<ThinkCardUserLog>>(
    THINK_API_URL + '/think/think-card-user-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
